//---------------------------------------------------------
// DynamixelpPbg̊{ (GoalPosition)
//                              Last Edit '11 04/08
// Copyright (c) BestTechnology CO.,LTD. 2005-2011
//---------------------------------------------------------
#include <stdio.h>

#include <AT91SAM7S.h>            // AT91SAM7S̓I/O`
#include <AT91SAM7S_BITDEFINE.h>  // AT91SAM7S̓I/Orbg`
#include <vic.h>                  // AT91SAM7S荞

#include <dx.h>                   // DynamixelCu

#define __UDP__                   // R\[֐̑I
#include "share\us.c"

//--------------------------------------------------------------
// L[͑҂
//--------------------------------------------------------------
char WaitForInputConsole (void) {
  char c;

  c = _us_getc ();
  if (c == '\33') { // ESCL[ŃvOI
#ifdef __UDP__
    udp_disconnect ();
    DX_wait (2000);
#endif
    RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
  }
  return c;
}

//--------------------------------------------------------------
// CXgNVpPbgɂʒuw
//--------------------------------------------------------------
void Position (uint8_t id, uint16_t p) {
  int j, l2;
  // p|[^p̃[N
  uint8_t  param[10];
  // pPbgMɎgpobt@ (obt@I[o[̓ubNĂȂ̂ő傫߂)
  static uint8_t tbuf[150], rbuf[150];
  uint16_t err;

  param[0] = ADDRESS_GOAL_POSITION;
  param[1] = p & 0xff;
  param[2] = (p >> 8) & 0xff;
  // CXgNVpPbgM
  j = DX_TxPacket (tbuf, id, INST_WRITE, param, 3, &err);
  // MCXgNVpPbgR\[ɑM
  DX_PrintBuffer (" <-", tbuf, j);
  // Xe[^XpPbgM
  j = DX_RxPacket (rbuf, sizeof(rbuf), &l2, _DX_READ_RESPONSE_TIME, &err);
  // MXe[^XpPbgR\[ɑM
  if (id != BROADCASTING_ID) DX_PrintBuffer (" ->", rbuf, j);
}

//--------------------------------------------------------------
// CXgNVpPbgɂړxݒ
//--------------------------------------------------------------
void Speed (uint8_t id, uint16_t p) {
  int j, l2;
  // p|[^p̃[N
  uint8_t  param[10];
  // pPbgMɎgpobt@ (obt@I[o[̓ubNĂȂ̂ő傫߂)
  static uint8_t tbuf[150], rbuf[150];
  uint16_t err;

  param[0] = ADDRESS_GOAL_SPEED;
  param[1] = p & 0xff;
  param[2] = (p >> 8) & 0xff;
  // CXgNVpPbgM
  j = DX_TxPacket (tbuf, id, INST_WRITE, param, 3, &err);
  DX_PrintBuffer (" <-",tbuf,j);
  // Xe[^XpPbgM
  j = DX_RxPacket (rbuf, sizeof(rbuf), &l2, _DX_READ_RESPONSE_TIME, &err);
  if (id != BROADCASTING_ID) DX_PrintBuffer (" ->", rbuf, j);
}

//----------------------------------------------------------------
// wIDAX-12̈ړ̔f
//----------------------------------------------------------------
bool MovingFlag (uint8_t id) {
  int   l1, l2;
  uint8_t  param[10];
  // pPbgMɎgpobt@ (obt@I[o[̓ubNĂȂ̂ő傫߂)
  static uint8_t tbuf[150], rbuf[150];
  uint16_t err;

  param[0] = ADDRESS_MOVING;
  param[1] = 1;
  // CXgNVpPbgM
  l1 = DX_TxPacket (tbuf, id, INST_READ, param, 2, &err);
  // Xe[^XpPbgM
  l1 = DX_RxPacket (rbuf, sizeof(rbuf), &l2, _DX_READ_RESPONSE_TIME, &err);

  return (l1 > 0) & (rbuf[5] != 0);
}

//--------------------------------------------------------------
// C
//--------------------------------------------------------------
void main (void) {
  // 荞݋
  enableIRQ ();

  // CONSOLE
  //  us.cɒ`ꂽ{[[gƑMobt@
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));

  // DX Library
  DX_Init (1000000, 7.4, _us_putc, NULL);

  WaitForInputConsole ();  // L[҂

  _us_puts ("start\n");

  // Dynamixel̃p[^bN
  //  pPbgROMGAȂlɃbN
  //  d؂ȊOɃbN͂łȂ
  DX_LockParam ();
  // ÑRvCAX߂ɐݒ
  DX_SetCompliance (BROADCASTING_ID, 1, 1, 100, 100);
  // ړxx߂
  Speed (BROADCASTING_ID, 50);
  // z[ʒu
  _us_puts ("Position=512\n");
  Position (BROADCASTING_ID, 512);

  const uint16_t posdata[4] = {400, 500, 600, 500};

  while (1) {
    int id, p;

    // eIDGoalPositionw
    _us_puts ("----- each axis pos send -----\n");
    for (id = 1; id <= 3; id++) {
      for (p = 0; p < 4; p++) {
        WaitForInputConsole ();  // L[҂
        _us_printf (" Position=%d only ID=%d\n", posdata[p], id);
        Position (id, posdata[p]);
        while (MovingFlag (id)) _us_rx_purge ();
      }
    }

    // lbg[NŜGoalPositionw
    _us_puts ("----- all axis pos send -----\n");
    for (p = 0; p < 4; p++) {
      WaitForInputConsole ();  // L[҂
      _us_printf (" Position=%d only ID=254\n", posdata[p]);
      Position (BROADCASTING_ID, posdata[p]);
      while (MovingFlag (1)) _us_rx_purge ();
    }

    // 1̓CXgNVŊeIDGoalPositionw
    _us_puts ("----- sync pos send -----\n");
    TSyncPosData pout[3]; // pf[^(3)
    pout[0].ID = 1; pout[1].ID = 2; pout[2].ID = 3;
    for (p = 0; p < 4; p++) {
      WaitForInputConsole ();  // L[҂
      _us_printf (" Position=%d sync\n", posdata[p]);
      for (id = 1; id <= 3; id++) pout[id-1].GoalPosition = posdata[p];
      DX_SetSyncPosition (pout, 3);
      while (MovingFlag (1)) _us_rx_purge ();
    }
  }
}
