//---------------------------------------------------------
// pPbgX[
//                              Last Edit '11 04/08
// Copyright (c) BestTechnology CO.,LTD. 2005-2011
//---------------------------------------------------------
/*
  FDIII-HCȂSAM7S I/OŒDynamixel𐧌䂷vOł͂ȂB܂A
  DynamixelCu͈؎gĂȂ(Ƃł͎gĂ͂Ȃ)B
  AT91SAM7S512𒼐ڐ䂵Ă̂ŉH\𗝉ĂȂꍇ͉ȂB

  DynamixelRtBM[^Ɠ̋@\񋟂vOŁAPCUSBoR
  őėf[^̂܂DynamixelƂ̒ʐM|[głUSART0փX[A
  Dynamixel̃pPbgUSBփX[邾BDynamixelRtBM[^
  킹ĂȂƂɎɕ֗B
*/

#include <stdio.h>
#include <stdbool.h>
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>

#include <vic.h>
#include <piocfg.h>
#include <us.h>
#include <vic.h>

#define _MONLED     ((uint32_t)1 << 3)  // PA3
#define _PB         ((uint32_t)1 << 4)  // PA4
#define _US0_RTS    ((uint32_t)1 << 7)  // PA7
#define _PUSHBUTTON (!(PIOA.PDSR & _PB))
#define Reboot  { udp_disconnect (); wait (2000); RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST; }

extern unsigned int CDCDSerialDriver_GetSerialBaudrate();

// PIO[qݒ
static const TPin DX_uspins[] = {
  {_US0_RTS, &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  {_MONLED,  &PIOA, PIOA_PID, PIO_OUTPUT_1, PIO_DEFAULT},
  {_PB,      &PIOA, PIOA_PID, PIO_INPUT,    PIO_PULLUP },
};

void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 5000; j++) ;
}

bool SetLed (bool On) {
  if (On) PIOA.CODR = _MONLED;
  else    PIOA.SODR = _MONLED;
  return On;
}

void main (void) {
  int i, len;
  static char s_udp[1000], s_us0[1000];
  char txbu[2000], rxbu[2000], txb0[1000], rxb0[1000];
  int b = 115200;
  bool led = false;

  enableIRQ ();

  PIO_Configure (DX_uspins, PIO_LISTSIZE (DX_uspins));

  udp_init (txbu, sizeof(txbu), rxbu, sizeof (rxbu));
  us0_pdc_init (b, txb0, sizeof (txb0), rxb0, sizeof (rxb0));
  USART0.MR = (USART0.MR & ~_US_USMODE) | _US_USMODE_RS485;

  while (1) {
    // USB̃{[[gXVoUS0̃{[[g֔f
    if (b != CDCDSerialDriver_GetSerialBaudrate()) {
      b = CDCDSerialDriver_GetSerialBaudrate();
      us0_pdc_baudrate (b);
    }
    // USB̒ʐMf[^擾US0ɑM
    if ((len = udp_rx_buff ())) {
      led = !SetLed (led);
      for (i = 0; i < len; i++) s_udp[i] = udp_getc ();
      us0_pdc_sys_puts (s_udp, len);
    }
    // US0̒ʐMf[^擾USBɑM
    if ((len = us0_pdc_rx_buff ())) {
      led = !SetLed (led);
      for (i = 0; i < len; i++) s_us0[i] = us0_pdc_getc ();
      udp_sys_puts (s_us0 ,len);
    };
    // vOI
    if (_PUSHBUTTON) {
      SetLed (false);
      Reboot;
    }
  }
}
