//---------------------------------------------------------
// USS3̌o
// Copyright (c) BestTechnology CO.,LTD. 2005-2010
//---------------------------------------------------------
#include <stdio.h>

#include <AT91SAM7S.h>            // AT91SAM7S̓I/O`
#include <AT91SAM7S_BITDEFINE.h>  // AT91SAM7S̓I/Orbg`
#include <vic.h>                  // AT91SAM7S荞

#include <dx.h>                   // DynamixelCu

#define __UDP__                   // R\[֐̑I
#include "share\us.c"

//--------------------------------------------------------------
// L[͑҂
//--------------------------------------------------------------
char WaitForInputConsole (void) {
  char c;

  c = _us_getc ();
  if (c == '\33') { // ESCL[ŃvOI
#ifdef __UDP__
    udp_disconnect ();
    DX_wait (2000);
#endif
    RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
  }
  return c;
}

//--------------------------------------------------------------
// ESCL[ŃvOI
//--------------------------------------------------------------
void ESCReboot (void) {
  if (_us_rx_buff ()) {
    if (_us_getc () == '\33') {
#ifdef __UDP__
      udp_disconnect ();
      DX_wait (2000);
#endif
      RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
    }
  }
}

//----------------------------------------------------------------
// C
//----------------------------------------------------------------
void main (void) {
  uint16_t err;

  // 荞݋
  enableIRQ ();

  // CONSOLE
  //  us.cɒ`ꂽ{[[gƑMobt@
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));

  // DX Library
  DX_Init (57143, 7.4, _us_putc, NULL);

  WaitForInputConsole ();

  _us_puts("start\n");

  uint8_t id = 0;
  uint16_t dist;

  while (1) {
    if (DX_ReadWordData (id, 42, &dist, 50, &err)) _us_printf ("Distance = %d    \r", dist);
    DX_wait (50);

    ESCReboot ();
  }
}
