//---------------------------------------------------------
// RvCAX
//                              Last Edit '11 04/08
// Copyright (c) BestTechnology CO.,LTD. 2005-2011
//---------------------------------------------------------
#include <stdio.h>

#include <AT91SAM7S.h>            // AT91SAM7S̓I/O`
#include <AT91SAM7S_BITDEFINE.h>  // AT91SAM7S̓I/Orbg`
#include <vic.h>                  // AT91SAM7S荞

#include <dx.h>                   // DynamixelCu

#define __UDP__                   // R\[֐̑I
#include "share\us.c"

//--------------------------------------------------------------
// L[͑҂
//--------------------------------------------------------------
char WaitForInputConsole (void) {
  char c;

  c = _us_getc ();
  if (c == '\33') { // ESCL[ŃvOI
#ifdef __UDP__
    udp_disconnect ();
    DX_wait (2000);
#endif
    RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
  }
  return c;
}

//--------------------------------------------------------------
// C
//--------------------------------------------------------------
void main (void) {
  // 荞݋
  enableIRQ ();

  // CONSOLE
  //  us.cɒ`ꂽ{[[gƑMobt@
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));

  // DX Library
  DX_Init (1000000, 8, _us_putc, NULL);

  // Dynamixel̃p[^bN
  //  pPbgROMGAȂlɃbN
  //  d؂ȊOɃbN͂łȂ
  DX_LockParam ();
  // ÑRvCAXȂ߂ɐݒ
  DX_SetCompliance (BROADCASTING_ID, 1, 1, 254, 254);
  // [^t[
  DX_EnableControl (BROADCASTING_ID, false);


  // L[͑҂
  WaitForInputConsole ();
  _us_puts ("start\n");

  // [^bN
  DX_EnableControl (BROADCASTING_ID, true);

  while (1) {
    // L[҂
    WaitForInputConsole ();
    _us_puts("Compliance=254\n");
    DX_SetCompliance (BROADCASTING_ID, 1, 1, 254, 254);

    // L[҂
    WaitForInputConsole ();
    _us_puts ("Compliance=200\n");
    DX_SetCompliance (BROADCASTING_ID, 1, 1, 200, 200);

    // L[҂
    WaitForInputConsole ();
    _us_puts ("Compliance=127\n");
    DX_SetCompliance (BROADCASTING_ID, 1, 1, 127, 127);

    // L[҂
    WaitForInputConsole ();
    _us_puts ("Compliance=64\n");
    DX_SetCompliance (BROADCASTING_ID, 1, 1, 64, 64);

    // L[҂
    WaitForInputConsole ();
    _us_puts ("Compliance=15\n");
    DX_SetCompliance (BROADCASTING_ID, 1, 1, 15, 15);
  }
}
