//---------------------------------------------------------
// ʒu擾
//                              Last Edit '11 04/08
// Copyright (c) BestTechnology CO.,LTD. 2005-2011
//---------------------------------------------------------
#include <stdio.h>

#include <AT91SAM7S.h>            // AT91SAM7S̓I/O`
#include <AT91SAM7S_BITDEFINE.h>  // AT91SAM7S̓I/Orbg`
#include <vic.h>                  // AT91SAM7S荞

#include <dx.h>                   // DynamixelCu

#define __UDP__                   // R\[֐̑I
#include "share\us.c"

//--------------------------------------------------------------
// L[͑҂
//--------------------------------------------------------------
char WaitForInputConsole (void) {
  char c;

  c = _us_getc ();
  if (c == '\33') { // ESCL[ŃvOI
#ifdef __UDP__
    udp_disconnect ();
    DX_wait (2000);
#endif
    RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
  }
  return c;
}

//--------------------------------------------------------------
// ESCL[ŃvOI
//--------------------------------------------------------------
void ESCReboot (void) {
  if (_us_rx_buff ()) {
    if (_us_getc () == '\33') {
#ifdef __UDP__
      udp_disconnect ();
      DX_wait (2000);
#endif
      RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
    }
  }
}

//--------------------------------------------------------------
// CXgNVpPbgɂʒu擾
//--------------------------------------------------------------
short GetPos2 (uint8_t id) {
  int j, l2;
  uint8_t  param[10];
  static uint8_t tbuf[150], rbuf[150];
  uint16_t err;

  param[0] = ADDRESS_PRESENT_POSITION;
  param[1] = 2;
  j = DX_TxPacket(tbuf, id, INST_READ, param, 2, &err);
//  DX_PrintBuffer("<-",tbuf,j);
  j = DX_RxPacket(rbuf, sizeof(rbuf), &l2, 20, &err);
//  DX_PrintBuffer("->",rbuf,j);

  return (j > 0) ? (short) (rbuf[5] + (rbuf[6] << 8)) : -1;
}

short GetPos (uint8_t id) {
  uint16_t result;
  uint16_t err;
  return DX_ReadWordData (id, ADDRESS_PRESENT_POSITION, &result, 100, &err) ? result : -1;
}

//--------------------------------------------------------------
// C
//--------------------------------------------------------------
void main (void) {
  // 荞݋
  enableIRQ ();

  // CONSOLE
  //  us.cɒ`ꂽ{[[gƑMobt@
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));

  // DX Library
  DX_Init (1000000, 8, _us_putc, NULL);

  WaitForInputConsole ();

  _us_puts("start\n");

  // [^̃p[^bN
  //  pPbgROMGAȂlɃbN܂
  //  bN͓d؂Kv܂
  DX_LockParam();

  // [^t[
  DX_EnableControl (BROADCASTING_ID, false);

  while(1) {
    _us_printf ("Position = [1]%4d [2]%4d [3]%4d    \r", GetPos (1), GetPos (2), GetPos (3));
    DX_wait (100);

    ESCReboot ();
  }
}
